
function AvoidTheInevitable_Load(self)	
	self:RegisterEvent('PLAYER_LOGIN');

	self:SetScript("OnEvent", function(self, event, ...) AvoidTheInevitable_OnEvent(self, event, ...) end);
	
	BonusRollFrame:HookScript("OnShow", function(self) AvoidTheInevitable_OnShow(self); end);
	BonusRollFrame:HookScript("OnHide", function(self) AvoidTheInevitable_OnHide(self); end);
	
	SLASH_AVOIDTHEINEVITABLE1, SLASH_AVOIDTHEINEVITABLE2 = "/avoid", "/avoidtheinevitable";
end

AvoidTheInevitable_Ace = LibStub("AceAddon-3.0"):NewAddon("AvoidTheInevitable");

function create_options(optionName, difficultyId, order)
	return {
		name = optionName,
		  ["type"] = "select",
		  style = "dropdown",
		  order = order or 100,
		  values = {
			["show"] = "Show",
			["hide"] = "Hide",
			["cancel"] = "Cancel"
		  },
		  set = function(info,val) AVOID_DB.profile.settings[difficultyId] = val; end,
		  get = function(info) return AVOID_DB.profile.settings[difficultyId] end
	};
end

local defaults = {
  ["profile"] = {
	["settings"] = {
		[1] = "show",
		[2] = "show",
		[23] = "show",
		[17] = "show",
		[14] = "show",
		[15] = "show",
		[16] = "show",
		[0] = "show"
	}
  }
}

-- Valeurs difficultyIndex : 
-- 1 : Donjon NM
-- 2 : Donjon HM
-- 23 : Donjon MM
-- 17 : Raid LFR
-- 14 : Raid NM
-- 15 : Raid HM
-- 16 : Raid MM

local options = {
    name = "Avoid The Inevitable",
    handler = AvoidTheInevitable,
    type = 'group',
    args = {
		description = {
			["type"] = "description",
			["name"] = "Show : show the bonus roll frame\nHide : hide the bonus roll frame but still allow it to be shown using the /avoid command\nCancel : cancel the roll completely",
			["order"] = 1
		},
		dungeon_mm = create_options("Dungeons - Mythic Difficulty", 23, 2),
		raid_lfr = create_options("Raids - LFR Difficulty", 17, 3),
		raid_nm = create_options("Raids - Normal Difficulty", 14, 4),
		raid_hm = create_options("Raids - Heroic Difficulty", 15, 5),
		raid_mm = create_options("Raids - Mythic Difficulty", 16, 6),
		others = create_options("Others (world bosses...)", 0, 7)
	}
}

AvoidTheInevitable = CreateFrame("FRAME", "AvoidTheInevitable");
AvoidTheInevitable_Load(AvoidTheInevitable);

AVOID_ROLL_ACTIVATED = false;
AVOID_DB = nil;

function AvoidTheInevitable_OnEvent(self, event, ...)
	if (event == "PLAYER_LOGIN") then
		AVOID_DB = LibStub("AceDB-3.0"):New("AvoidTheInevitableDB", defaults);
		LibStub("AceConfig-3.0"):RegisterOptionsTable("AvoidTheInevitable", options, {"/avoidoptions"});
		LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AvoidTheInevitable", "Avoid the Inevitable");	
		print("[Avoid the Inevitable] Addon loaded");
	end
end

function SlashCmdList.AVOIDTHEINEVITABLE(msg, editbox)
	if (msg == "cancel") then
		if (AVOID_ROLL_ACTIVATED == true) then
			BonusRollFrame_CloseBonusRoll();
		else
			print("[Avoid the Inevitable] There is no bonus roll to cancel.");
		end
	elseif (msg == "show") then
		if (AVOID_ROLL_ACTIVATED == true) then
			BonusRollFrame:SetAlpha(1);
			print("[Avoid the Inevitable] The bonus roll frame has been shown.");
		else
			print("[Avoid the Inevitable] There is no bonus roll frame to show.");
		end
	else
		LibStub("AceConfigDialog-3.0"):Open("AvoidTheInevitable");
	end
end

function AvoidTheInevitable_OnHide(self)
	AVOID_ROLL_ACTIVATED = false;
	print("[Avoid the Inevitable] The bonus roll has been cancelled.");
end

function AvoidTheInevitable_OnShow(self)
	AVOID_ROLL_ACTIVATED = true;
	name, instanceType, difficultyIndex, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, mapID = GetInstanceInfo();
	
	settings = AVOID_DB.profile.settings;
	
	if (settings[difficultyIndex] == nil) then
		difficultyIndex = 0;
	end
	
	if (settings[difficultyIndex] == "cancel") then
		BonusRollFrame_CloseBonusRoll();
	elseif(settings[difficultyIndex] == "hide") then
		BonusRollFrame:SetAlpha(0);
		print("[Avoid the Inevitable] The bonus roll frame has been hidden but the roll has not been cancelled. You can still show the frame using /avoid show, cancel the bonus roll using /avoid cancel or just wait for it to expire.");
	end
end